﻿

local currentStatColor = 0;
local statMonitorLoadTimer = 0;

function MageNuggetsSP_OnUpdate(self, elapsed) 
 self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;
 if (self.TimeSinceLastUpdate > 0.3) then   
    
    local spellpower = GetSpellBonusDamage(3)
    local attackpower, posBuff, negBuff = UnitAttackPower("player");
    local crit = roundStat(GetSpellCritChance(3));
    local haste = roundStat(UnitSpellHaste("player"));
    local mastery = roundStat(GetMasteryEffect());
    local multistrike = roundStat(GetMultistrike());
    local leech = roundStat(GetLifesteal());
    local versatility = roundStat(GetCombatRatingBonus(29));
    local base, stat, posBuff, negBuff = UnitStat("player",5);
    local spirit = stat;
    local baseRegen, castingRegen = GetManaRegen()
    local manaregen = roundZero(castingRegen*5);
    local statCount = 0;
    local readout = {};
    local stats = {};
 
    if(mageNuggetsStatMonitor.spellpower == true)then
        statCount = statCount + 1;
        readout[statCount] = "Power";
        stats[statCount] = spellpower;
    end
    if(mageNuggetsStatMonitor.attackpower == true)then
        statCount = statCount + 1;
        readout[statCount] = "Power";
        stats[statCount] = attackpower;
    end
    if(mageNuggetsStatMonitor.crit == true)then
        statCount = statCount + 1;
        readout[statCount] = "Crit";
        stats[statCount] = crit;
    end
    if(mageNuggetsStatMonitor.haste == true)then
        statCount = statCount + 1;
        readout[statCount] = "Haste";
        stats[statCount] = haste;
    end
    if(mageNuggetsStatMonitor.mastery == true)then
        statCount = statCount + 1;
        readout[statCount] = "Mastery";
        stats[statCount] = mastery;
    end
    if(mageNuggetsStatMonitor.multistrike == true)then
        statCount = statCount + 1;
        readout[statCount] = "Multi";
        stats[statCount] = multistrike;
    end
    if(mageNuggetsStatMonitor.leech == true)then
        statCount = statCount + 1;
        readout[statCount] = "Leech";
        stats[statCount] = leech;
    end
    if(mageNuggetsStatMonitor.versatility == true)then
        statCount = statCount + 1;
        readout[statCount] = "Versatil";
        stats[statCount] = versatility;
    end
    if(mageNuggetsStatMonitor.spirit == true)then
        statCount = statCount + 1;
        readout[statCount] = "Spirit";
        stats[statCount] = spirit;
    end
    if(mageNuggetsStatMonitor.manaregen == true)then
        statCount = statCount + 1;
        readout[statCount] = "Regen";
        stats[statCount] = manaregen;
    end
    if(statCount > 0) then
        local i = 1;
        while(statCount >= i) do
            _G["MageNugSP_FrameText"..i]:SetText(readout[i]);
            _G["MageNugSP_FrameValueText"..i]:SetText(stats[i]);
            i = i + 1;
        end
        local i = 10;
        while(statCount < i) do
           _G["MageNugSP_FrameText"..i]:SetText("");
           _G["MageNugSP_FrameValueText"..i]:SetText("");
            i = i - 1;
        end
    else
        local i = 10;
        while(statCount < i) do
           _G["MageNugSP_FrameText"..i]:SetText("");
           _G["MageNugSP_FrameValueText"..i]:SetText("");
            i = i - 1;
        end
    end
    for k in pairs (readout) do
        readout[k] = nil
    end
    for j in pairs (stats) do
        stats[j] = nil
    end    
    if statMonitorLoadTimer < 4 then
        statMonitorLoadTimer = statMonitorLoadTimer + 1;
        setStatMonitorHeight(statCount);
        dressStatMonitorText();
    end
    statCount = 0;
    self.TimeSinceLastUpdate = 0;
   end
end   


function setStatMonitorHeight(statCount) 
    if(statCount==0)then
        MageNugSP_Frame:SetHeight(20);    
    elseif(statCount==1)then
        MageNugSP_Frame:SetHeight(20);
    elseif(statCount==2)then
        MageNugSP_Frame:SetHeight(30);    
    elseif(statCount==3)then
        MageNugSP_Frame:SetHeight(40);
    elseif(statCount==4)then
        MageNugSP_Frame:SetHeight(49);
    elseif(statCount==5)then
        MageNugSP_Frame:SetHeight(59);
    elseif(statCount==6)then
        MageNugSP_Frame:SetHeight(69);
    elseif(statCount==7)then
        MageNugSP_Frame:SetHeight(79);
    elseif(statCount==8)then
        MageNugSP_Frame:SetHeight(89);
    elseif(statCount==9)then
        MageNugSP_Frame:SetHeight(99);
    elseif(statCount==10)then
        MageNugSP_Frame:SetHeight(110);
    end
end


function mageNuggetsStatMonitorToggle(statType)
    if(statType == "spellpower") then
        if (mageNuggetsStatMonitor.spellpower == false) then
            mageNuggetsStatMonitor.spellpower = true;
        else
            mageNuggetsStatMonitor.spellpower = false;
        end
    elseif(statType == "attackpower") then
        if (mageNuggetsStatMonitor.attackpower == false) then
            mageNuggetsStatMonitor.attackpower = true;
        else
            mageNuggetsStatMonitor.attackpower = false;
        end
    elseif(statType == "crit") then
        if (mageNuggetsStatMonitor.crit == false) then
            mageNuggetsStatMonitor.crit = true;
        else
            mageNuggetsStatMonitor.crit = false;
        end
    elseif(statType == "haste") then
        if (mageNuggetsStatMonitor.haste == false) then
            mageNuggetsStatMonitor.haste = true;
        else
            mageNuggetsStatMonitor.haste = false;
        end
    elseif(statType == "mastery") then
        if (mageNuggetsStatMonitor.mastery == false) then
            mageNuggetsStatMonitor.mastery = true;
        else
            mageNuggetsStatMonitor.mastery = false;
        end
    elseif(statType == "multistrike") then
        if (mageNuggetsStatMonitor.multistrike == false) then
            mageNuggetsStatMonitor.multistrike = true;
        else
            mageNuggetsStatMonitor.multistrike = false;
        end
    elseif(statType == "leech") then
        if (mageNuggetsStatMonitor.leech == false) then
            mageNuggetsStatMonitor.leech = true;
        else
            mageNuggetsStatMonitor.leech = false;
        end
    elseif(statType == "versatility") then
        if (mageNuggetsStatMonitor.versatility == false) then
            mageNuggetsStatMonitor.versatility = true;
        else
            mageNuggetsStatMonitor.versatility = false;
        end
    elseif(statType == "spirit") then
        if (mageNuggetsStatMonitor.spirit == false) then
            mageNuggetsStatMonitor.spirit = true;
        else
            mageNuggetsStatMonitor.spirit = false;
        end
    elseif(statType == "manaregen") then
        if (mageNuggetsStatMonitor.manaregen == false) then
            mageNuggetsStatMonitor.manaregen = true;
        else
            mageNuggetsStatMonitor.manaregen = false;
        end
    end
    setStatMonitorHeight(dressStatMonitorText());
    dressStatMonitorText();
end

function roundStat(value) 
    return math.floor(value*math.pow(10,2)+0.5) / math.pow(10,2) 
end

function roundZero(inputNum)
    return math.floor(inputNum*math.pow(10,0)+0.5) / math.pow(10,0) 
end

function setStatMonitorStats()
    if (mageNuggetsStatMonitor.spellpower == nil)then
        mageNuggetsStatMonitor.spellpower = true
    end
    if (mageNuggetsStatMonitor.spellpower == true) then
        MageNugSP_SpellPowerCheckButton:SetChecked(true);
    else
        MageNugSP_SpellPowerCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.attackpower == nil)then
        mageNuggetsStatMonitor.attackpower = true
    end
    if (mageNuggetsStatMonitor.attackpower == true) then
        MageNugSP_AttackPowerCheckButton:SetChecked(true);
    else
        MageNugSP_AttackPowerCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.crit == nil)then
        mageNuggetsStatMonitor.crit = true
    end
    if (mageNuggetsStatMonitor.crit == true) then
        MageNugSP_CritCheckButton:SetChecked(true);
    else
        MageNugSP_CritCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.haste == nil)then
        mageNuggetsStatMonitor.haste = true
    end
    if (mageNuggetsStatMonitor.haste == true) then
        MageNugSP_HasteCheckButton:SetChecked(true);
    else
        MageNugSP_HasteCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.mastery == nil)then
        mageNuggetsStatMonitor.mastery = true
    end
    if (mageNuggetsStatMonitor.mastery == true) then
        MageNugSP_MasteryCheckButton:SetChecked(true);
    else
        MageNugSP_MasteryCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.multistrike == nil)then
        mageNuggetsStatMonitor.multistrike = true
    end
    if (mageNuggetsStatMonitor.multistrike == true) then
        MageNugSP_MultistrikeCheckButton:SetChecked(true);
    else
        MageNugSP_MultistrikeCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.leech == nil)then
        mageNuggetsStatMonitor.leech = true
    end
    if (mageNuggetsStatMonitor.leech == true) then
        MageNugSP_LeechCheckButton:SetChecked(true);
    else
        MageNugSP_LeechCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.versatility == nil)then
        mageNuggetsStatMonitor.versatility = true
    end
    if (mageNuggetsStatMonitor.versatility == true) then
        MageNugSP_VersatilityCheckButton:SetChecked(true);
    else
        MageNugSP_VersatilityCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.spirit == nil)then
        mageNuggetsStatMonitor.spirit = true
    end
    if (mageNuggetsStatMonitor.spirit == true) then
        MageNugSP_SpiritCheckButton:SetChecked(true);
    else
        MageNugSP_SpiritCheckButton:SetChecked(false);
    end
    
    if (mageNuggetsStatMonitor.manaregen == nil)then
        mageNuggetsStatMonitor.manaregen = true
    end
    if (mageNuggetsStatMonitor.manaregen == true) then
        MageNugSP_ManaRegenCheckButton:SetChecked(true);
    else
        MageNugSP_ManaRegenCheckButton:SetChecked(false);
    end
end

function setCurrentStatColor(index)
    currentStatColor = index;
end

function dressStatMonitorText()
    local statCount = 0;
    if(mageNuggetsStatMonitor.spellpower == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.spellpowerR,mageNuggetsStatMonitor.spellpowerG,mageNuggetsStatMonitor.spellpowerB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.spellpowerValueR,mageNuggetsStatMonitor.spellpowerValueG,mageNuggetsStatMonitor.spellpowerValueB,1);
    end
    if(mageNuggetsStatMonitor.attackpower == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.attackpowerR,mageNuggetsStatMonitor.attackpowerG,mageNuggetsStatMonitor.attackpowerB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.attackpowerValueR,mageNuggetsStatMonitor.attackpowerValueG,mageNuggetsStatMonitor.attackpowerValueB,1);
    end
    if(mageNuggetsStatMonitor.crit == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.critR,mageNuggetsStatMonitor.critG,mageNuggetsStatMonitor.critB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.critValueR,mageNuggetsStatMonitor.critValueG,mageNuggetsStatMonitor.critValueB,1);
    end
    if(mageNuggetsStatMonitor.haste == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.hasteR,mageNuggetsStatMonitor.hasteG,mageNuggetsStatMonitor.hasteB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.hasteValueR,mageNuggetsStatMonitor.hasteValueG,mageNuggetsStatMonitor.hasteValueB,1);
    end
    if(mageNuggetsStatMonitor.mastery == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.masteryR,mageNuggetsStatMonitor.masteryG,mageNuggetsStatMonitor.masteryB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.masteryValueR,mageNuggetsStatMonitor.masteryValueG,mageNuggetsStatMonitor.masteryValueB,1);
    end
    if(mageNuggetsStatMonitor.multistrike == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.multistrikeR,mageNuggetsStatMonitor.multistrikeG,mageNuggetsStatMonitor.multistrikeB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.multistrikeValueR,mageNuggetsStatMonitor.multistrikeValueG,mageNuggetsStatMonitor.multistrikeValueB,1);
    end
    if(mageNuggetsStatMonitor.leech == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.leechR,mageNuggetsStatMonitor.leechG,mageNuggetsStatMonitor.leechB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.leechValueR,mageNuggetsStatMonitor.leechValueG,mageNuggetsStatMonitor.leechValueB,1);
    end
    if(mageNuggetsStatMonitor.versatility == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.versatilityR,mageNuggetsStatMonitor.versatilityG,mageNuggetsStatMonitor.versatilityB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.versatilityValueR,mageNuggetsStatMonitor.versatilityValueG,mageNuggetsStatMonitor.versatilityValueB,1);
    end
    if(mageNuggetsStatMonitor.spirit == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.spiritR,mageNuggetsStatMonitor.spiritG,mageNuggetsStatMonitor.spiritB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.spiritValueR,mageNuggetsStatMonitor.spiritValueG,mageNuggetsStatMonitor.spiritValueB,1);
    end
    if(mageNuggetsStatMonitor.manaregen == true) then
        statCount = statCount + 1;
        _G["MageNugSP_FrameText"..statCount]:SetTextColor(mageNuggetsStatMonitor.manaregenR,mageNuggetsStatMonitor.manaregenG,mageNuggetsStatMonitor.manaregenB,1);
        _G["MageNugSP_FrameValueText"..statCount]:SetTextColor(mageNuggetsStatMonitor.manaregenValueR,mageNuggetsStatMonitor.manaregenValueG,mageNuggetsStatMonitor.manaregenValueB,1);
    end
    return statCount;
end



function statMonitorColorSelect()
    if(currentStatColor == 1) then
        mageNuggetsStatMonitor.spellpowerR, mageNuggetsStatMonitor.spellpowerG, mageNuggetsStatMonitor.spellpowerB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 2) then
        mageNuggetsStatMonitor.spellpowerValueR, mageNuggetsStatMonitor.spellpowerValueG, mageNuggetsStatMonitor.spellpowerValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 3) then
        mageNuggetsStatMonitor.attackpowerR, mageNuggetsStatMonitor.attackpowerG, mageNuggetsStatMonitor.attackpowerB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 4) then
        mageNuggetsStatMonitor.attackpowerValueR, mageNuggetsStatMonitor.attackpowerValueG, mageNuggetsStatMonitor.attackpowerValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 5) then
        mageNuggetsStatMonitor.critR, mageNuggetsStatMonitor.critG, mageNuggetsStatMonitor.critB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 6) then
        mageNuggetsStatMonitor.critValueR, mageNuggetsStatMonitor.critValueG, mageNuggetsStatMonitor.critValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 7) then
        mageNuggetsStatMonitor.hasteR, mageNuggetsStatMonitor.hasteG, mageNuggetsStatMonitor.hasteB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 8) then
        mageNuggetsStatMonitor.hasteValueR, mageNuggetsStatMonitor.hasteValueG, mageNuggetsStatMonitor.hasteValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 9) then
        mageNuggetsStatMonitor.masteryR, mageNuggetsStatMonitor.masteryG, mageNuggetsStatMonitor.masteryB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 10) then
       mageNuggetsStatMonitor.masteryValueR, mageNuggetsStatMonitor.masteryValueG, mageNuggetsStatMonitor.masteryValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 11) then
        mageNuggetsStatMonitor.multistrikeR, mageNuggetsStatMonitor.multistrikeG, mageNuggetsStatMonitor.multistrikeB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 12) then
        mageNuggetsStatMonitor.multistrikeValueR, mageNuggetsStatMonitor.multistrikeValueG, mageNuggetsStatMonitor.multistrikeValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 13) then
        mageNuggetsStatMonitor.leechR, mageNuggetsStatMonitor.leechG, mageNuggetsStatMonitor.leechB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 14) then
        mageNuggetsStatMonitor.leechValueR, mageNuggetsStatMonitor.leechValueG, mageNuggetsStatMonitor.leechValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 15) then
        mageNuggetsStatMonitor.versatilityR, mageNuggetsStatMonitor.versatilityG, mageNuggetsStatMonitor.versatilityB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 16) then
        mageNuggetsStatMonitor.versatilityValueR, mageNuggetsStatMonitor.versatilityValueG, mageNuggetsStatMonitor.versatilityValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 17) then
        mageNuggetsStatMonitor.spiritR, mageNuggetsStatMonitor.spiritG, mageNuggetsStatMonitor.spiritB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 18) then
        mageNuggetsStatMonitor.spiritValueR, mageNuggetsStatMonitor.spiritValueG, mageNuggetsStatMonitor.spiritValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 19) then
        mageNuggetsStatMonitor.manaregenR, mageNuggetsStatMonitor.manaregenG, mageNuggetsStatMonitor.manaregenB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    elseif(currentStatColor == 20) then
        mageNuggetsStatMonitor.manaregenValueR, mageNuggetsStatMonitor.manaregenValueG, mageNuggetsStatMonitor.manaregenValueB = MageNugSP_ColorPickerFrameColorSelect:GetColorRGB();
    end
    dressStatMonitorText();
end